//--------------------------------------------------------------------------------
//  OpenGL Wrapping Class (Initialize, others)
//    Copyright  (C)  2005  kei mesuda  
//    (http://www.yomogi.sakura.ne.jp/~si)
//--------------------------------------------------------------------------------
// - DWORD Fݒ 
//  void GL::ClearColordw(DWORD dwColor)  // glClearColor for DWORD
//  void GL::Colordw(DWORD dwColor)       // glColor* for DWORD
// 
// - ֐̐ݒ
//  void GL::SetAlphaBlend()    // At@ 
//  void GL::SetAddBlend()      // Z 
//  void GL::SetMultBlend()     // ZiAt@lj 
//  void GL::SetScreenBlend()   // XN[iAt@lj
//  void GL::SetXorBlend()      // rI_aiAt@lj
//  void GL::SetInvertBlend()   // ]iAt@lj
// 
// - Fog̐ݒ
//  ֐
//    void GL::SetFog()
//  
//    GLfloat fFogDensity;  x 
//    GLfloat fFogStart;    Jn 
//    GLfloat fFogEnd;      I 
//    GLuint  dwFogColor;   F 
//    GLint   iFogMode;     [h(ȗ GL_LINEAR) 
// 
// - DisplayList ̐
//  ֐
//    GLint GL::ComposeDisplayList()
//    void  GL::ComposeEnd()
//  Tv 
//    ComposeDisplayList() ̕ԒlƂāC DisplayList  ID 擾D 
//    DisplayList 쐬͈͂CComposeDisplayList() ` ComposeEnd() ŋށD
// 
// - "ƍw肷" Projection Matrix ݒ
//  ֐
//    void GL::Screen(float fWidth, float fHeight, float fZnear, float fZfar)
//    void GL::ScreenPers(float fPersAngle, float fWidth, float fHeight, float fZnear, float fZfar)
//    void GL::ScreenFrustum(float fZcamera, float x, float y, float fWidth, float fHeight, float fZnear, float fZfar)
//    void GL::ScreenOrtho(float x, float y, float fWidth, float fHeight, float fZnear, float fZfar)
//  
//    fWidth / fHeight; ʂ̍ƕ
//    fZnear / fZfar;   z̕`͈
//    x / y;            ʍ̍W
//    fPersAngle;       ʉ̎p
//    fZcamera;         ʂJ܂łz
//--------------------------------------------------------------------------------

#ifndef _CORE_NAMESPACEGL_INCLUDED
#define _CORE_NAMESPACEGL_INCLUDED

#include "Math.h"
#include "GLMatrixSaver.h"
#pragma message ("<< CORE_MESSAGE >>  include namespace GL")

//--------------------------------------------------------------------------------
//  }N
//--------------------------------------------------------------------------------
// DWORD->GLfloat Color
#define GLGetRValuef(dwColor)   (GLclampf)(((BYTE)(dwColor)) * 0.0039215686f)
#define GLGetGValuef(dwColor)   (GLclampf)(((BYTE)((dwColor)>>8)) * 0.0039215686f)
#define GLGetBValuef(dwColor)   (GLclampf)(((BYTE)((dwColor)>>16)) * 0.0039215686f)
#define GLGetAValuef(dwColor)   (GLclampf)(((BYTE)((dwColor)>>24)) * 0.0039215686f)
#define GLGetRValue(dwColor)    (GLubyte)(dwColor)
#define GLGetGValue(dwColor)    (GLubyte)((dwColor) >> 8)
#define GLGetBValue(dwColor)    (GLubyte)((dwColor) >> 16)
#define GLGetAValue(dwColor)    (GLubyte)((dwColor) >> 24)

// GLfloat Color->DWORD
#define GLRGBAf(r, g, b, a)     (DWORD)((BYTE)((r)*255) | (((BYTE)((g)*255)) << 8) | (((BYTE)((b)*255)) << 16) | (((BYTE)((a)*255)) << 24))

//--------------------------------------------------------------------------------
//  ֐ 
//--------------------------------------------------------------------------------
namespace GL {
// DWORD  glClearColor 
inline void ClearColordw(DWORD dwColor)
{
    glClearColor(GLGetRValuef(dwColor), 
                 GLGetGValuef(dwColor), 
                 GLGetBValuef(dwColor),
                 GLGetAValuef(dwColor));
}

// DWORD  glColor* 
inline void Colordw(DWORD dwColor)
{
    glColor4ub(GLGetRValue(dwColor), 
               GLGetGValue(dwColor), 
               GLGetBValue(dwColor),
               GLGetAValue(dwColor));
}

// At@ɐݒ
inline void SetAlphaBlend()
{
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
}

// Zɐݒ
inline void SetAddBlend()
{
    glBlendFunc(GL_SRC_ALPHA, GL_ONE);
}

// ZɐݒiAt@lj
inline void SetMultBlend()
{
    glBlendFunc(GL_ZERO, GL_SRC_COLOR);
}

// XN[ɐݒiAt@lj
inline void SetScreenBlend()
{
    glBlendFunc(GL_ONE_MINUS_DST_COLOR, GL_ONE);
}

// XORɐݒiAt@lj
inline void SetXorBlend()
{
    glBlendFunc(GL_ONE_MINUS_DST_COLOR, GL_ONE_MINUS_SRC_COLOR);
}

// ]ɐݒiAt@lj
inline void SetInvertBlend()
{
    glBlendFunc(GL_ONE_MINUS_DST_COLOR, GL_ZERO);
}

// glFog() ̃bv
inline void SetFog(GLfloat fFogDensity, GLfloat fFogStart, GLfloat fFogEnd, GLuint dwFogColor, GLint iFogMode = GL_LINEAR)
{
    float v[4] = {GLGetRValuef(dwFogColor), 
                  GLGetGValuef(dwFogColor), 
                  GLGetBValuef(dwFogColor), 
                  GLGetAValuef(dwFogColor)};
    glFogi(GL_FOG_MODE,     iFogMode);
    glFogf(GL_FOG_DENSITY,  fFogDensity);
    glFogf(GL_FOG_START,    fFogStart);
    glFogf(GL_FOG_END,      fFogEnd);
    glFogfv(GL_FOG_COLOR,   v);
}

// glGenLists() -> glNewList(GL_COMPILE) -> glEndList()
// DisplayList 쐬͈͂CCompile() ` CompileEnd() ŋށD
inline GLint ComposeDisplayList()
{
    GLint iListIndex = glGenLists(1);
    glNewList(iListIndex, GL_COMPILE);
    return iListIndex;
}

inline void ComposeEnd()
{
    glEndList();
}

// w萳e
inline void Screen(float fWidth, float fHeight, float fZnear, float fZfar)
{
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    float w_half = fWidth * 0.5f;
    float h_half = fHeight * 0.5f;
    glOrtho(-w_half, w_half, -h_half, h_half, fZnear, fZfar);
    glMatrixMode(GL_MODELVIEW);
}

// z=0ʂɂ镝w蓧e
inline void ScreenPers(float fPersAngle, float fWidth, float fHeight, float fZnear, float fZfar)
{
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    float dist = fWidth * 0.5f / tanf(DEGREEtoRADIAN(fPersAngle) * 0.5f);
    float ratio = (dist + fZnear) / dist * 0.5f;
    float w_half = fWidth * ratio;
    float h_half = fHeight * ratio;

    glFrustum(-w_half, w_half, -h_half, h_half, dist + fZnear, dist + fZfar);
    glTranslatef(0, 0, -dist);
    glMatrixMode(GL_MODELVIEW);
}

// z=0ʂɂ镝w莋̐ϓe
inline void ScreenFrustum(float fZcamera, float x, float y, float fWidth, float fHeight, float fZnear, float fZfar)
{
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    float r = (fZcamera - fZnear) / fZcamera;
    glFrustum(x*r, y*r, (x+fWidth)*r, (y+fHeight)*r, fZnear - fZcamera, fZfar - fZcamera);
    glTranslatef(0, 0, fZcamera);
    glMatrixMode(GL_MODELVIEW);
}

// w萳e
inline void ScreenOrtho(float x, float y, float fWidth, float fHeight, float fZnear, float fZfar)
{
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(x, x+fWidth, y, y+fHeight, fZnear, fZfar);
    glMatrixMode(GL_MODELVIEW);
}

}; // namespace GL

#endif //_CORE_NAMESPACEGL_INCLUDED
