//--------------------------------------------------------------------------------
//  SDL Sound Wrapping Class
//    Copyright  (C)  2005  kei mesuda  
//    (http://www.yomogi.sakura.ne.jp/~si)
//--------------------------------------------------------------------------------
//  BPM WaveĐNX
//
//--------------------------------------------------------------------------------

#include "Math.h"
#include "SDLEffector.h"

#define  _SDLSEQ_CHANNEL_MAX    16



//------------------------------------------------------------
// V[PTNX
//------------------------------------------------------------
class CSDLSequencer
{
//------------------------------------------------------------
// oNX
//------------------------------------------------------------
public:
    //--------------------------------------------------
    // `lf[^NX
    //--------------------------------------------------
    class CSDLSeqChannel {
    //--------------------------------------------------
    // oϐ
    //--------------------------------------------------
    public:
        Uint8*  m_pData;        // Đf[^
        int     m_iDataLength;  // Đf[^TCY

        int     m_iVolume;      // Đ
        int     m_iLoopCount;   // [vJE^
        int     m_iDelay;       // Đ܂ł̑ҋ@oCg
        int     m_iSilence;     // 񃋁[vĐ܂ł̖ҋ@oCg
        int     m_iEndPoint;    // ŏI[vōĐIf[^ʒu
        int     m_iStartPoint;  // Xg[ɏލĐf[^ʒu

        int     m_fiFadeT;      // tF[hʁi16bit ̌Œ菬j
        int     m_fiFadeDT;     // tF[hʕωi16bit ̌Œ菬j

        bool    m_bPlaying;     // 

    //--------------------------------------------------
    // o֐
    //--------------------------------------------------
    public:
        // 
        void Init()
        {
            m_pData = NULL;
            m_iDataLength = 0;

            m_iVolume = 0;
            m_iLoopCount = -1;
            m_iDelay = 0;
            m_iSilence = 0;
            m_iEndPoint = 0;
            m_iStartPoint = 0;

            m_fiFadeT = 0;
            m_fiFadeDT = 0;

            m_bPlaying = false;
        }

        // I
        void Exit()
        {
            m_iLoopCount = -1;
            m_pData = NULL;
            m_bPlaying = false;
        }

        // ̏I
        void Stop(int iStopDelay)
        {
            if (m_pData == NULL) return;
            if (!m_bPlaying) {
                // ҋ@ȂI
                Exit();
            } else {
                // ȂĐIʒuvZ
                int iStopPoint = m_iStartPoint + iStopDelay;
                // [v
                int iLoop = iStopPoint / m_iDataLength;
                // ŏI[v̍ĐIʒu
                if (m_iLoopCount >= 0 || m_iLoopCount <= -(iLoop + 1)) {
                    m_iLoopCount = -(iLoop + 1);
                    if (iLoop == 0) m_iDataLength = iStopPoint;
                    else            m_iEndPoint   = iStopPoint - iLoop * m_iDataLength;
                }
            }
        }

        // FadeIn
        void FadeIn(int iFadeDelay, int iFadeLength)
        {
            // 16bit ̌Œ菬gp
            m_fiFadeT  = 0;
            m_fiFadeDT = (128 << 16) / (iFadeLength >> 8);
        }

        // FadeOut
        void FadeOut(int iFadeDelay, int iFadeLength)
        {
            // 16bit ̌Œ菬gp
            m_fiFadeT  = (128 << 16);
            m_fiFadeDT = - ((128 << 16) / (iFadeLength >> 8));
        }

        // ҋ@ireturn true ȂXg[ɏ݂vj
        bool Wait(int iStreamLength)
        {
            if (m_pData == NULL) return false;
            if (m_iDelay < iStreamLength) {
                m_bPlaying = true;
                return true;
            }
            m_iDelay -= iStreamLength;
            return false;
        }

        // Xg[ɏ
        void Streaming(Uint8* stream, int iStreamLength)
        {
            // [] = [Xg[] - [ҋ@]
            int iCopyLength = iStreamLength - m_iDelay;

            // [f[^擪AhX] + [] > [f[^]
            if (m_iStartPoint + iCopyLength > m_iDataLength) {
                // ݂̏Ńf[^Ō܂œBꍇ
                // [] = [f[^] - [f[^擪AhX]
                iCopyLength = m_iDataLength - m_iStartPoint;
                // Xg[Ƀf[^Rs[
                AddData((short*)&(stream[m_iDelay]), (short*)&(m_pData[m_iStartPoint]), iCopyLength);

                // [vJE^CNg
                ++m_iLoopCount;
                switch(m_iLoopCount) {
                case 0:
                    // [vJE^ == 0 ȂĐI
                    Exit();
                    return;
                case -1:
                    // [vJE^ == 1 Ȃ玟ĐI|Cgݒ
                    m_iDataLength = m_iEndPoint;
                    break;
                }

                // [Xg[ʒu] += [Rs[σoCg] + [[v܂ł̖ҋ@oCg]
                m_iDelay += iCopyLength + m_iSilence;
                // [] = [Xg[] - [ҋ@]
                iCopyLength = iStreamLength - m_iDelay;
                // ݂̏ł́C[v̍ŏɓBȂ
                if (iCopyLength <= 0) return;
                // [vf[^擪珑
                m_iStartPoint = 0;
            }

            // Xg[Ƀf[^Rs[
            AddData((short*)&(stream[m_iDelay]), (short*)&(m_pData[m_iStartPoint]), iCopyLength);

            // [f[^擪AhX] 񏑂񂾕i߂
            m_iStartPoint += iCopyLength;
            // ̓Xg[̐擪珑
            m_iDelay = 0;
        }

    private:
        // Xg[ɉZ
        void AddData(short* stream, short* dat, int len)
        {
            int i;
            int vol = m_iVolume;

            // sampling Pʂɕϊ
            len >>= 1;

            if (m_fiFadeDT == 0) {
                // ʏZ
                for (i=0; i<len; i++) stream[i] += (dat[i]*vol)>>7;
            } else {
                // tF[fBOe[u̍쐬
                char achFadeTable[64];
                int  imax = len >> 8;
                for (int i=0; i<imax; i++, m_fiFadeT+=m_fiFadeDT) achFadeTable[i] = (m_fiFadeT >> 16);
                // tF[hZ
                for (i=0; i<len; i++) stream[i] += (dat[i]*vol*achFadeTable[i>>8])>>14;
                // tF[hI
                if (m_fiFadeT < 0) Exit();
                else if (m_fiFadeT > (128 << 16)) m_fiFadeDT = 0;
            }
        }
    };


//------------------------------------------------------------
// oϐ
//------------------------------------------------------------
private:
    // p[^
    float   m_fBeatPerMinuts;           // PԂ̃r[g
    float   m_fBytePerBeats;            // Pr[g̃oCg
    float   m_fBytePerFineBeats;        // m_funcFineCallBack Ăяo^C~ÕoCg
    float   m_fSecondPerByte;           // PoCgɑb
    float   m_fLatency;                 // obt@ɂ郌CeV[
    DWORD   m_dwPastByte;               // Ă̌o߃oCg
    int     m_iBeatCounter;             // Ẵr[gJE^
    int     m_iFineBeatCounter;         // m_funcFineCallBack ĂяoJE^
    int     m_iBeatCallBackInterval;    // R[obNr[gԊu
    bool    m_bPlay;                    // V[PTĂ邩

    // `l
    CSDLSeqChannel  m_Channel[_SDLSEQ_CHANNEL_MAX][2];  // `lf[^
    int             m_iActiveSub[_SDLSEQ_CHANNEL_MAX];  // gp̃Tu`lԍ

    // r[gR[obN֐
    bool    (*m_funcBeatCallBack)(DWORD, float);
    bool    (*m_funcFineCallBack)(DWORD, float);

    // GtFN^
    ISDLEffect*     m_pEffector;

//------------------------------------------------------------
// o֐
//------------------------------------------------------------
public:
    CSDLSequencer()
    {
        // 
        m_fBeatPerMinuts = 0.0f;
        m_fBytePerBeats = 0.0f;
        m_fBytePerFineBeats = 0.0f;
        m_fSecondPerByte = 0.0f;
        m_fLatency = 0.0f;
        m_dwPastByte = 0;
        m_iBeatCounter = 0;
        m_iFineBeatCounter = 0;
        m_iBeatCallBackInterval = 4;
        m_bPlay = false;

        ResetAllChannel();

        m_funcBeatCallBack = NULL;
        m_funcFineCallBack = NULL;

        m_pEffector = NULL;
    }

    ~CSDLSequencer()
    {
        // Xg[ĐR[obN֐͂
        Mix_HookMusic(NULL, NULL);
    }


//------------------------------------------------------------
// 
//------------------------------------------------------------
public:
    //------------------------------------------------------------------------------------------------------------------------
    // bool CSDLSequencer::Init()
    //   Tv; V[PT̏
    //   Ԓl; ی
    //   ; float fBPM;                  쓮e|
    //         bool (*funcBeatCallBack)();  ̃^C~OŃR[obN֐
    //         int iCallBackInterval;       R[obN锏Ԋui4ȂC41R[obNj
    //         float fLatencyEstimation;    obt@ĐԂ̉V[PXɎgpĂƌς邩D0.5ʂÓH
    //------------------------------------------------------------------------------------------------------------------------
    bool Init(float fBPM, bool (*funcBeatCallBack)(DWORD, float), int iCallBackInterval, float fLatencyEstimation = 0.0f)
    {
        // SDLCore  SDL_mixer ݒQ
        CSDLCore::tag_SDLInfo::tag_Mixer*   pSetting = &(CSDLCore::s_pInstance->m_SDLInfo.Mixer);
        // 16bit/stereo ȊO͕s
        if (pSetting->m_usFormat != AUDIO_S16LSB || !pSetting->m_bStereo) return false;

        // p[^
        m_iBeatCallBackInterval = iCallBackInterval;
        m_dwPastByte            = 0;
        m_iBeatCounter          = 0;
        m_iFineBeatCounter      = 0;
        m_fBeatPerMinuts        = fBPM;
        m_fBytePerBeats         = pSetting->m_ulFreq * 240.0f / fBPM;   // 240  = 60[sec/min]*2[byte/data]*2[stereo]
        m_fBytePerFineBeats     = 0;
        m_fSecondPerByte        = 0.25f / pSetting->m_ulFreq;           // 0.25 = 1 / (2[byte/data]*2[stereo])
        m_fLatency              = (float)pSetting->m_ulBufferSize / (float)pSetting->m_ulFreq * (1.0f-fLatencyEstimation);
        m_bPlay                 = false;

        // r[gR[obN֐
        m_funcBeatCallBack      = funcBeatCallBack;
        m_funcFineCallBack      = NULL;

        // `l
        ResetAllChannel();

        // Xg[ĐR[obN֐̓o^
        Mix_HookMusic(fpMusicHookCallBack, this);

        return true;
    }

    // ׂ݂̃R[obN֐ݒ肷
    void SetFineCallBack(bool (*funcFineCallBack)(DWORD, float), int iQuantize)
    {
        m_funcFineCallBack  = funcFineCallBack;
        m_fBytePerFineBeats = m_fBytePerBeats * 4 / iQuantize;
        m_iFineBeatCounter  = 0;
    }

    // GtFN^̒ǉ
    void AddEffector(ISDLEffect* pEffect)
    {
        if (m_pEffector == NULL) m_pEffector = pEffect;
        else m_pEffector->Connect(pEffect);
    }

    // S`lZbg
    void ResetAllChannel()
    {
        // `l
        for (int i=0; i<_SDLSEQ_CHANNEL_MAX; i++) {
            m_Channel[i][0].Init();
            m_Channel[i][1].Init();
            m_iActiveSub[i] = 0;
        }
    }

//------------------------------------------------------------
// s
//------------------------------------------------------------
public:
    //------------------------------------------------------------------------------------------------------------------------
    // float CSDLSequencer::PlaySound()
    //   Tv; EF[uf[^ BPM Đ
    //   Ԓl; ɂ锭̒x[sec]D
    //   ; CSDLSound* pSound;       Đf[^
    //         int        iChannel;     Đ`l̎w (0-15)
    //         int        iLoopCount;   [v   (0ŖJԂ)
    //         int        iVolume;      {[ (0-128)
    //         y^C~O̎wz
    //         float      fQuantize;    𓯊^C~ODfQuantize=4 ŎlDfQuantize=16 16D
    //         float      fDelay;       xDfDelay=1 ŎlxD
    //         yf[^؏o̎wz
    //         float      fStartPoint;  JnʒuDfStartPoint=1 Ŏlォ؂oĔD0 wōŏ甭D
    //         float      fLength;      DfLength=1 Ŏl𔭉D0 wŃf[^D
    //         float      fVoidLength;  [vȂڂɐ݂閳̑傫DfVoidLength=0.05f Ŏl5%̖
    //------------------------------------------------------------------------------------------------------------------------
    float PlaySound(CSDLSound* pSound, 
                    int iChannel, 
                    int iLoopCount    = 1, 
                    int iVolume       = 80, 
                    float fQuantize   = 4, 
                    float fDelay      = 0, 
                    float fStartPoint = 0, 
                    float fLength     = 0, 
                    float fVoidLength = 0)
    {
        // xvZ
        int iDataDelay = CalcDataDelayByQuantize(fQuantize, fDelay);
        int iStartPos = 0;

        // w`lgp̏ꍇ
        if (IsUsing(iChannel)) {
            if (m_Channel[iChannel][m_iActiveSub[iChannel]].m_iDelay != iDataDelay) {
                // ݂̃`l̔~߂
                m_Channel[iChannel][m_iActiveSub[iChannel]].Stop(iDataDelay);
                // Tu`l؂ւ
                m_iActiveSub[iChannel] = 1 - m_iActiveSub[iChannel];
            }
        }

        // `lf[^ݒ
        CSDLSeqChannel* pChannel = &(m_Channel[iChannel][m_iActiveSub[iChannel]]);

        // lݒ
        pChannel->m_iLoopCount  = -iLoopCount;  // lŃ[v񐔂w肷D
        pChannel->m_iVolume     = iVolume;
        pChannel->m_iSilence    = 0;
        pChannel->m_iDelay      = iDataDelay;
        pChannel->m_iStartPoint = 0;
        pChannel->m_fiFadeT     = 0;
        pChannel->m_fiFadeDT    = 0;
        pChannel->m_bPlaying    = false;

        // Đf[^
        if (fStartPoint == 0.0f) {
            // ؂ow薳
            pChannel->m_pData = pSound->GetData();
        } else {
            // ؂owL
            iStartPos = CalcDataLengthFromBeat(fStartPoint);
            if (iStartPos > (int)pSound->GetLength()) return 0;
            pChannel->m_pData = &(pSound->GetData()[iStartPos]);
        }

        // Đf[^̌vZ
        if (fLength == 0.0f) {
            // IWif[^gp
            pChannel->m_iDataLength = pSound->GetLength();
        } else {
            // 󌄒vZ
            pChannel->m_iSilence    = CalcDataLengthFromBeat(fVoidLength);
            // r[gw肩f[^vZ
            pChannel->m_iDataLength = CalcDataLengthFromBeat(fLength) - pChannel->m_iSilence;
            if (pChannel->m_iDataLength > (int)pSound->GetLength()-iStartPos) {
                // IWif[^蒷ꍇCԂݒ肷
                pChannel->m_iSilence    = pChannel->m_iDataLength - pSound->GetLength() - iStartPos;
                pChannel->m_iDataLength = pSound->GetLength() - iStartPos;
            }
        }
        // ŏI[vłŌ܂ōĐ
        pChannel->m_iEndPoint   = pChannel->m_iDataLength;

        // ̒xvZĕԂ
        return CalcDelayByQuantize(iDataDelay);
    }

    float StopSound(int iChannel, float fQuantize=4, float fDelay=0)
    {
        // xvZ
        int iDataDelay = CalcDataDelayByQuantize(fQuantize, fDelay);
        // `l̔~߂
        m_Channel[iChannel][m_iActiveSub[iChannel]].Stop(iDataDelay);
        // ̒xvZĕԂ
        return CalcDelayByQuantize(iDataDelay);
    }

    float FadeSound(int iChannel, bool bFadeIn, float fQuantize=4, float fDelay=0, float fLength = 16)
    {
        // xvZ
        int iDataDelay = CalcDataDelayByQuantize(fQuantize, fDelay);
        int iLength    = CalcDataLengthFromBeat(fLength);
        // `lFader
        if (bFadeIn) m_Channel[iChannel][m_iActiveSub[iChannel]].FadeIn(iDataDelay, iLength);
        else         m_Channel[iChannel][m_iActiveSub[iChannel]].FadeOut(iDataDelay, iLength);
        // ̒xvZĕԂ
        return CalcDelayByQuantize(iDataDelay);
    }

    void Stop()
    {
        m_bPlay = false;
    }

    void Start()
    {
        m_bPlay = true;
        m_dwPastByte   = 0;
        m_iBeatCounter = 0;
        m_iFineBeatCounter = 0;
        ResetAllChannel();
    }

    void Pause()
    {
        m_bPlay = false;
    }

    void Resume()
    {
        m_bPlay = true;
    }


//------------------------------------------------------------
// Q
//------------------------------------------------------------
public:
    // `lgp
    inline bool IsUsing(int iChannel)
    {
        return (m_Channel[iChannel][m_iActiveSub[iChannel]].m_pData != NULL);
    }

    // `lĐ
    inline bool IsFlooding(int iChannel)
    {
        return (m_Channel[iChannel][0].m_bPlaying && m_Channel[iChannel][1].m_bPlaying);
    }

    // BPM Q
    inline float GetBPM()
    {
        return m_fBeatPerMinuts;
    }

    // `l
    inline int GetFreeChannel()
    {
        for (int i=0; i<_SDLSEQ_CHANNEL_MAX; i++) if (!IsUsing(i)) return i;
        return 15;
    }
   
    // lPʒf[^oCgvZ
    inline int CalcDataLengthFromBeat(float fLengthInBeat)
    {
        return ((int)(fLengthInBeat * m_fBytePerBeats)) & 0x7ffffffc;
    }

    // f[^甏vZ
    inline float CalcBeatFromDataLength(int iDataLength)
    {
        return (float)iDataLength / m_fBytePerBeats;
    }

    // xbvZ
    inline float CalcDelayByQuantize(float fQuantize, float fDelay)
    {
        return CalcDelayByQuantize(CalcDataDelayByQuantize(fQuantize, fDelay));
    }

    // xbvZioCgj
    inline float CalcDelayByQuantize(int iDataDelay)
    {
        return iDataDelay * m_fSecondPerByte + m_fLatency;
    }

private:
    // xoCgvZ
    inline int CalcDataDelayByQuantize(float fQuantize, float fDelay)
    {
        // [Obh] = [1ߓ̃f[^] / [Quantize]
        float fGrid = m_fBytePerBeats * 4 / fQuantize;
        // [^C~O] = 4Byte ۂߍ ([Obh] - ([Đς݃f[^] + [Delayf[^]) % [Obh]) 
        return ((int)(fGrid - fmodf((m_dwPastByte + fDelay * m_fBytePerBeats + fGrid - 1), fGrid)) + 2) & 0x7ffffffc;
    }


//------------------------------------------------------------
// SDL_mixer Ă΂Xg[ĐpR[obN֐
//------------------------------------------------------------
public:
    static void fpMusicHookCallBack(void *udata, Uint8 *stream, int len)
    {
        CSDLSequencer* pSeq = (CSDLSequencer*)udata;
        if (!pSeq->m_bPlay) return;

        // r[gށDԊuŃr[gR[obN֐ĂԁD
        pSeq->CountBeat(len);
        pSeq->FineCallBack(len);
        // `lf[^Xg[ɍD
        pSeq->StreamingChannel(stream, len);
        // }X^[GtFNg
        pSeq->MasterEffect(stream, len);
        // ^CJE^i߂D
        pSeq->CountTime(len);
    }


//--------------------------------------------------
// Xg[ĐTu[`
//--------------------------------------------------
private:
    // Xg[Đf[^Cr[gJEg
    void CountBeat(DWORD dwDataLength)
    {
        // [̃r[gʒu] = [r[gJE^] * [1Beat̃oCg]
        DWORD dwNextBeat = (DWORD)(m_iBeatCounter * m_fBytePerBeats);
        // [̃r[gʒu] < [Xg[Đς݃f[^] + [̃Xg[Đf[^]
        if (dwNextBeat < m_dwPastByte + dwDataLength) {
            // ̃Xg[ĐŁC1r[g
            // m_iBeatCallBackInterval r[gԊuŃR[obN
            if ((m_iBeatCounter % m_iBeatCallBackInterval) == 0 && m_funcBeatCallBack != NULL) {
                // r[gR[obN֐Ă
                m_funcBeatCallBack(m_iBeatCounter, CalcDelayByQuantize(dwNextBeat - m_dwPastByte));
            }
            // r[gJE^CNg
            m_iBeatCounter++;
        }
    }

    // 4BeatZR[obN֐Ăяo
    void FineCallBack(DWORD dwDataLength)
    {
        if (m_funcFineCallBack == NULL) return;
        // [̃r[gʒu] = [JE^] * [1FineBeat̃oCg]
        DWORD dwNextBeat;

        while(true) {
            dwNextBeat = (DWORD)(m_iFineBeatCounter * m_fBytePerFineBeats);
            // [̃r[gʒu] < [Xg[Đς݃f[^] + [̃Xg[Đf[^]
            if (dwNextBeat < m_dwPastByte + dwDataLength) {
                // R[obN֐Ă
                m_funcFineCallBack(m_iFineBeatCounter, CalcDelayByQuantize(dwNextBeat - m_dwPastByte));
                // r[gJE^CNg
                m_iFineBeatCounter++;
            } else break;
        }
    }

    // S`lf[^Xg[ɍ
    void StreamingChannel(Uint8 *stream, int len)
    {
        int i;
        for (i=0; i<_SDLSEQ_CHANNEL_MAX; i++) {
            if (m_Channel[i][0].Wait(len)) m_Channel[i][0].Streaming(stream, len);
            if (m_Channel[i][1].Wait(len)) m_Channel[i][1].Streaming(stream, len);
        }
    }

    // }X^[GtFNg
    void MasterEffect(Uint8 *stream, int len)
    {
        ISDLEffect* pEffect;
        for (pEffect = m_pEffector; pEffect != NULL; pEffect = pEffect->GetNextEffect()) {
            if (!pEffect->IsActive()) continue;
            if (!pEffect->Exec(stream, len)) return;
        }
    }

    // ԍXV
    void CountTime(DWORD dwDataLength)
    {
        // Xg[Đς݃f[^CNg
        m_dwPastByte += dwDataLength;
    }
};
